.586
.MODEL FLAT, STDCALL
OPTION CASEMAP:NONE
   
INCLUDE \GeneSys\include\windows.inc
INCLUDE \GeneSys\include\kernel32.inc
INCLUDE \GeneSys\include\urlmon.inc

INCLUDELIB \GeneSys\lib\kernel32.lib
INCLUDELIB \GeneSys\lib\urlmon.lib

;wsprintfA PROTO C :DWORD,:VARARG
;wsprintf equ <wsprintfA>

main                    PROTO
ConsOut                 PROTO :PTR BYTE
UnzipFile               PROTO :PTR BYTE, :PTR BYTE
UzPrintRoutine          PROTO :PTR BYTE, :DWORD
UzReplaceRoutine        PROTO :PTR BYTE
UzPasswordRoutine       PROTO :PTR BYTE, :DWORD, :PTR BYTE, :PTR BYTE
UzMessageRoutine        PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :BYTE, :PTR BYTE, :PTR BYTE, :DWORD, :BYTE

; 68 BYTEs, 17 DWORDs
DCL STRUCT
    ExtractOnlyNewer    DWORD ?
    SpaceToUnderscore   DWORD ?
    PromptToOverwrite   DWORD ?
    fQuiet              DWORD ?
    ncflag              DWORD ?
    ntflag              DWORD ?
    nvflag              DWORD ?
    nfflag              DWORD ?
    nzflag              DWORD ?
    ndflag              DWORD ?
    noflag              DWORD ?
    naflag              DWORD ?
    nZIflag             DWORD ?
    C_flag              DWORD ?
    fPrivilege          DWORD ?
    lpszZipFN           PBYTE ?   ; PTR BYTE
    lpszExtractDir      PBYTE ?   ; PTR BYTE
DCL ENDS

; 44 BYTEs, 11 DWORDs
USERFUNCTIONS STRUCT
    DLLPRNT             DWORD ?    ; function pointer
    DLLSND              DWORD ?    ; function pointer
    DLLREPLACE          DWORD ?    ; function pointer
    DLLPASSWORD         DWORD ?    ; function pointer
    DLLMESSAGE          DWORD ?    ; function pointer
    DLLSERVICE          DWORD ?    ; function pointer
    TotalSizeComp       DWORD ?
    TotalSize           DWORD ?
    CompFactor          DWORD ?   
    NumMembers          DWORD ?
    cchComment          WORD  ?
    pad                 WORD  ?
USERFUNCTIONS ENDS

.DATA?

    szPath              BYTE MAX_PATH dup(?)
           
.DATA
   
    szURL               BYTE "http://x86assembly.codegurus.org/GeneSys.zip", 0
    szDestPath          BYTE "D:\install", 0   
    szFile              BYTE "GeneSys.zip", 0

    szTitle             BYTE "Get my library", 13, 10, 0
    szRetrieve          BYTE " Retrieving file - ", 0
    szUnzip             BYTE " Unzipping file  - ", 0
    szSuccess           BYTE "Success", 13, 10, 0
    szFailure           BYTE "Failed!", 13, 10, 13, 10, 0
    szCrLf              BYTE 13, 10, 0
    szSlash             BYTE "\", 0       
    szLib               BYTE "unzip32.dll", 0
    szProcName          BYTE "Wiz_SingleEntryUnzip", 0

.CODE

; 
start:

    call main
    INVOKE ExitProcess, eax

; 

main PROC

    INVOKE ConsOut, ADDR szTitle

    ;// Retrieve zip file
    INVOKE GetTempPath, MAX_PATH, ADDR szPath
    .IF eax == 0
        INVOKE ConsOut, ADDR szFailure
        jmp @F
    .ENDIF
    INVOKE lstrcat, ADDR szPath, ADDR szSlash
    .IF eax == 0
        INVOKE ConsOut, ADDR szFailure
        jmp @F       
    .ENDIF   
    INVOKE lstrcat, ADDR szPath, ADDR szFile
    .IF eax == 0
        INVOKE ConsOut, ADDR szFailure
        jmp @F       
    .ENDIF
    INVOKE ConsOut, ADDR szRetrieve
    INVOKE URLDownloadToFile, NULL, ADDR szURL, ADDR szPath, 0, NULL
    ; URLDownloadToFile returns S_OK (0) if successful
    .IF eax != S_OK
        INVOKE ConsOut, ADDR szFailure
        jmp @F       
    .ENDIF
    INVOKE ConsOut, ADDR szSuccess
    ;// Unzip zip file
    INVOKE ConsOut, ADDR szUnzip
    INVOKE UnzipFile, ADDR szPath, ADDR szDestPath
    ; UnzipFile returns 0 on failure
    .IF eax == 0
        push edx     ; error code is in edx   
        INVOKE ConsOut, ADDR szFailure
        pop eax      ; return the error code
    .ELSE
        INVOKE ConsOut, ADDR szSuccess
        INVOKE ConsOut, ADDR szCrLf
        xor eax, eax ; return 0   
    .ENDIF
  @@: 
    ret
main ENDP
; 
ConsOut PROC pString:PTR BYTE
    ; ConsOut returns 0 on failure
    LOCAL hStdOut      :DWORD
    LOCAL dwNumToWrite :DWORD
    LOCAL dwNumWritten :DWORD
   
    INVOKE GetStdHandle, STD_OUTPUT_HANDLE
    ; GetStdHandle returns INVALID_HANDLE_VALUE on failure
    .IF eax == INVALID_HANDLE_VALUE
        xor eax, eax
        jmp @F
    .ELSE
        mov hStdOut, eax         
        INVOKE lstrlen, pString
        ; lstrlen returns 0 on failure
        .IF eax == 0
            jmp @F
        .ELSE   
            mov dwNumToWrite, eax         
            INVOKE WriteConsole, hStdOut, pString, dwNumToWrite, ADDR dwNumWritten, NULL
            ; WriteConsole returns 0 on failure
            .IF eax
                mov eax, dwNumWritten
            .ENDIF
        .ENDIF
    .ENDIF   
  @@: 
    ret
ConsOut ENDP
; 
UnzipFile PROC pArcName:PTR BYTE, pDestPath:PTR BYTE

    ; Uses UNZIP32.DLL (www.Info-Zip.org)
    ; UnzipFile returns 0 on failure
   
    LOCAL theDCL               :DCL
    LOCAL theUF                :USERFUNCTIONS
    LOCAL hUnzipDll            :DWORD
    LOCAL Wiz_SingleEntryUnzip :DWORD   ; function pointer
   
    INVOKE LoadLibrary, ADDR szLib
    .IF eax == 0
        jmp done        ; return 0
    .ELSE
        mov hUnzipDll, eax
    .ENDIF
   
    INVOKE GetProcAddress, hUnzipDll, ADDR szProcName
    .IF eax == 0
        INVOKE FreeLibrary, hUnzipDll
        xor eax, eax    ; return 0
        jmp done
    .ELSE
        mov Wiz_SingleEntryUnzip, eax
    .ENDIF   
   
    ; Fill in the DCL struct
    mov theDCL.ExtractOnlyNewer, 0  ; Do not extract only newer
    mov theDCL.SpaceToUnderscore, 0 ; Do not convert space to underscore
    mov theDCL.PromptToOverwrite, 0 ; "Overwrite all" selected -> no query mode
    mov theDCL.fQuiet, 0            ; 0 = all messages
                                    ; 1 = fewer messages
                                    ; 2 = no messages
    mov theDCL.ncflag, 0            ; Write to stdout if true                                     
    mov theDCL.ntflag, 0            ; Test zip file if true
    mov theDCL.nvflag, 0            ; Give a verbose listing if true
    mov theDCL.nfflag, 0            ; Do not freshen existing files only   
    mov theDCL.nzflag, 0            ; Display a zip file comment if true
    mov theDCL.ndflag, 1            ; Recreate directories
                                    ; 0 = junk paths from filenames
                                    ; 1 = safe usage of paths in filenames (skip "../")
                                    ; 2 = allow unsafe path components (dir traversals)
    mov theDCL.noflag, 1            ; Over-write all files if true   
    mov theDCL.naflag, 0            ; Do not convert CR to CRLF
    mov theDCL.nZIflag, 0           ; Get ZipInfo if true
    mov theDCL.C_flag, 0            ; case insensitive if true
    mov theDCL.fPrivilege, 1        ; 1 = restore ACLs in user mode
                                    ; 2 = try to use privileges for restoring ACLs
    mov eax, pArcName
    mov theDCL.lpszZipFN, eax       ; The archive name
   
    mov eax, pDestPath
    mov theDCL.lpszExtractDir, eax  ; The directory to extract to. This is set
                                    ;   to NULL if you are extracting to the
                                    ;   current directory.
    ; Fill in the USERFUNCTIONS struct                                   
    lea eax, UzPrintRoutine                     
    mov theUF.DLLPRNT, eax
   
    mov eax, NULL   
    mov theUF.DLLSND, eax
   
    lea eax, UzReplaceRoutine   
    mov theUF.DLLREPLACE, eax
   
    lea eax, UzPasswordRoutine   
    mov theUF.DLLPASSWORD, eax
   
    lea eax, UzMessageRoutine
    mov theUF.DLLMESSAGE, eax
   
    lea eax, UzServiceRoutine   
    mov theUF.DLLSERVICE, eax
   
    ; The values below are filled in by the DLL
    mov eax, 0
    mov theUF.TotalSizeComp, eax
    mov theUF.TotalSize, eax
    mov theUF.CompFactor, eax
    mov theUF.NumMembers, eax
    mov theUF.cchComment, ax

    ; Call the DLL function                   
    ; INVOKE Wiz_SingleEntryUnzip, 0, NULL, 0, NULL, ADDR theDCL, ADDR theUF
    lea eax, theUF
    push eax
    lea eax, theDCL
    push eax
    push NULL
    push 0
    push NULL
    push 0
    call Wiz_SingleEntryUnzip
    ;add esp, 24        ; Wiz_SingleEntryUnzip cleans up the stack
   
    .IF eax == 0        ; success
        INVOKE FreeLibrary, hUnzipDll 
        mov eax, 1      ; return 1
    .ELSE               ; error
        push eax
        INVOKE FreeLibrary, hUnzipDll
        pop edx         ; error code in edx
        xor eax, eax    ; return 0       
    .ENDIF   
     
  done:
    ret
   
UnzipFile ENDP
; 
; These are dummy routines. Needed to satisfy the pointers to functions. 
; 
UzPrintRoutine PROC pString:PTR BYTE, dwLen:DWORD
    ;INVOKE ConsOut, pstring ; remark this line out if you don't want to see status messages
    mov eax, dwLen           ; return the string length
    ret
UzPrintRoutine ENDP
; 
UzReplaceRoutine PROC p1:PTR BYTE
    mov eax, 1  ; return 1
    ret
UzReplaceRoutine ENDP
; 
UzPasswordRoutine PROC p1:PTR BYTE, dw1:DWORD, p2:PTR BYTE, p3:PTR BYTE
    mov eax, 1  ; return 1
    ret
UzPasswordRoutine ENDP
; 
UzMessageRoutine PROC dw1:DWORD, dw2:DWORD, dw3:DWORD, dw4:DWORD, dw5:DWORD, dw6:DWORD, dw7:DWORD, dw8:DWORD, b1:BYTE, p1:PTR BYTE, p2:PTR BYTE, dw9:DWORD, b2:BYTE
    mov eax, 1  ; does not need to return anything (void)
    ret
UzMessageRoutine ENDP
; 
UzServiceRoutine PROC p1:PTR BYTE, dw1:DWORD
    mov eax, 0   ; if this procedure returns a non-zero value
                 ; Wiz_SingleEntryUnzip will fail
    ret
UzServiceRoutine ENDP
; 
END start
